#include <sstream>
#include <string>
#include <fstream>

 std::string gameCount;
 std::string tempcount;
 std::string playmoves;
 std::string playhours;
 std::string playsecos;
 std::string DatFilePath;
 int bestminute, bestsecond, bestmove;
 int cheers=0;
 int is_magic=1;
 //int is_perfect=0;
 
 int is_Challenge=0;
 
 void loadstats()
  {
   std::fstream pfinds(DatFilePath.c_str(), std::ios::in|std::ios::binary);
    if(pfinds.good()){
   pfinds.unsetf(std::ios::skipws);   /* read spaces */        
 
                std::getline(pfinds,playhours,' ');
                std::getline(pfinds,playsecos,' ');
                std::getline(pfinds,playmoves,' ');
   pfinds.close();
    }
     else {
    std::fstream miastats(DatFilePath.c_str(),std::ios::out);
    miastats<<"59 59 998";
    miastats.close();
    playhours="0";
    playsecos="00";
    playmoves="0";
    miastats.close();
    }
  }
  
 void highscores()
  {
  std::fstream iscores(DatFilePath.c_str(), std::ios::in | std::ios::binary);
  
  if(iscores.good()){
  iscores>>bestminute>>bestsecond>>bestmove;
  iscores.close();
  cheers=0;
   }
  }
  
 void newstats()
  {
   std::ofstream champs(DatFilePath.c_str(), std::ios::out | std::ios::binary);
   if(bestsecond>9){
   champs<<bestminute<<" "<<bestsecond<<" "<<bestmove<<" ";
   }
   else{
   champs<<bestminute<<" 0"<<bestsecond<<" "<<bestmove<<" ";
   }
   champs.close();
   cheers=1;
  }
    
 
 void IntToString ( int number ) //Prelude's function
 {
  std::ostringstream oss;
  oss<< number;
  gameCount=oss.str();
}  

void checkWin(){
 if(board[1]==1 && board[2]==2 && board[3]==3 && board[4]==4 && board[5]==5
    && board[6]==6 && board[7]==7 && board[8]==8 && board[9]==9 &&
    board[10]==10 && board[11]==11 && board[12]==12 && board[13]==13 &&
    board[14]==14 && board[15]==15)
  {
   gameRunning = 0;
   gameWon=1;
   gameCount.erase();
  }
  if(board[1]==1 && board[2]==2 && board[3]==3 && board[4]==4 && board[5]==5
    && board[6]==6 && board[7]==7 && board[8]==8 && board[9]==9 &&
    board[10]==10 && board[11]==11 && board[12]==12 && board[13]==13 &&
    board[14]==15 && board[15]==14)
  { 
  gameRunning = 0;
  gameCount.erase();
  gameWon=2;
   }
   
   if(is_magic==1)
    {
  if(board[1]+ board[2]+ board[3]+ board[4]==30
   && board[5]+ board[6]+ board[7]+ board[8]==30
   && board[9]+ board[10]+ board[11]+ board[12]==30 
   && board[13]+ board[14]+ board[15] + board[16]==30
   && board[1]+ board[5]+ board[9]+ board[13]==30
   && board[2]+ board[6]+ board[10]+ board[14]==30
   && board[3]+ board[7]+ board[11]+ board[15]==30
   && board[4]+ board[8]+ board[12]+ board[16]==30
   && board[1]+ board[6]+ board[11]+ board[16]==30
   && board[4]+ board[7]+ board[10]+ board[13]==30)
  { 
  gameRunning = 0;
  gameCount.erase();
  gameWon=3;
   } 
  }
        
  }
  
void fillboard()
    {
     int hatpick;
      for (int t=0; t<17; t++)
       {
       board[t]=0;
       }
    // board[16] = 0;

    if(scramble==0)
     {
      srand (time(NULL));
      }

    scramble++; //Global value held so we do not repeat initial seeding -
    
   if(seedone==0){
    hatpick=rand() % 16 + 1;
    ++seedone;
    ID_BUTAPOS=hatpick;
    board[hatpick]=1;

    if(hatpick<5){
    posah=81*hatpick-51; posaz=54;
     }
       if(hatpick>4 && hatpick<9){
       posah=81*(hatpick-4)-51; posaz=135;
      }

    if(hatpick>8 && hatpick<13){
    posah=81*(hatpick-8)-51; posaz=216;
     }

       if(hatpick>12 && hatpick<17){
       posah=81*(hatpick-12)-51; posaz=297;
      }
     }

//End 1st button (ID_BUTAPOS) assignment & continue loop below until unas-
//signed number is selected from rand().  We then assign vectors<pos> with
//the value of this button {Value==2}. This continues for buttons 2 - 15

    while(seedone==1)
     {
     hatpick=rand() % 16 + 1;  //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS)
     {
     ID_BUTBPOS=hatpick;
     board[hatpick]=2;
     ++seedone;

    if(hatpick<5){
    posbh=81*hatpick-51; posbz=54;
     }
       if(hatpick>4 && hatpick<9){
       posbh=81*(hatpick-4)-51; posbz=135;
      }

    if(hatpick>8 && hatpick<13){
    posbh=81*(hatpick-8)-51; posbz=216;
     }

       if(hatpick>12 && hatpick<17){
       posbh=81*(hatpick-12)-51; posbz=297;
      }
    }
     }

// ************************************************************************

    while(seedone==2)
     {
     hatpick=rand() % 16 + 1;  //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS)
     {
     ID_BUTCPOS=hatpick;
     board[hatpick]=3;
     ++seedone;

    if(hatpick<5){
    posch=81*hatpick-51; poscz=54;
     }
       if(hatpick>4 && hatpick<9){
       posch=81*(hatpick-4)-51; poscz=135;
      }

    if(hatpick>8 && hatpick<13){
    posch=81*(hatpick-8)-51; poscz=216;
     }

       if(hatpick>12 && hatpick<17){
       posch=81*(hatpick-12)-51; poscz=297;
      }
    }
     }

// *************************************************************************

    while(seedone==3)
     {
     hatpick=rand() % 16 + 1;  //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS)
     {
     ID_BUTDPOS=hatpick;
     board[hatpick]=4;
     ++seedone;

    if(hatpick<5){
    posdh=81*hatpick-51; posdz=54;
     }
       if(hatpick>4 && hatpick<9){
       posdh=81*(hatpick-4)-51; posdz=135;
      }

    if(hatpick>8 && hatpick<13){
    posdh=81*(hatpick-8)-51; posdz=216;
     }

       if(hatpick>12 && hatpick<17){
       posdh=81*(hatpick-12)-51; posdz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==4)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
        && hatpick!=ID_BUTDPOS)
     {
     ID_BUTEPOS=hatpick;
     board[hatpick]=5;
     ++seedone;

    if(hatpick<5){
    poseh=81*hatpick-51; posez=54;
     }
       if(hatpick>4 && hatpick<9){
       poseh=81*(hatpick-4)-51; posez=135;
      }

    if(hatpick>8 && hatpick<13){
    poseh=81*(hatpick-8)-51; posez=216;
     }

       if(hatpick>12 && hatpick<17){
       poseh=81*(hatpick-12)-51; posez=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==5)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
        && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS)
     {
     ID_BUTFPOS=hatpick;
     board[hatpick]=6;
     ++seedone;

    if(hatpick<5){
    posfh=81*hatpick-51; posfz=54;
     }
       if(hatpick>4 && hatpick<9){
       posfh=81*(hatpick-4)-51; posfz=135;
      }

    if(hatpick>8 && hatpick<13){
    posfh=81*(hatpick-8)-51; posfz=216;
     }

       if(hatpick>12 && hatpick<17){
       posfh=81*(hatpick-12)-51; posfz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==6)
     {
     hatpick=rand() % 16 + 1;  //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
        && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS)
     {
     ID_BUTGPOS=hatpick;
     board[hatpick]=7;
     ++seedone;

    if(hatpick<5){
    posgh=81*hatpick-51; posgz=54;
     }
       if(hatpick>4 && hatpick<9){
       posgh=81*(hatpick-4)-51; posgz=135;
      }

    if(hatpick>8 && hatpick<13){
    posgh=81*(hatpick-8)-51; posgz=216;
     }

       if(hatpick>12 && hatpick<17){
       posgh=81*(hatpick-12)-51; posgz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==7)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
        && hatpick!=ID_BUTGPOS)
     {
     ID_BUTHPOS=hatpick;
     board[hatpick]=8;
     ++seedone;

    if(hatpick<5){
    poshh=81*hatpick-51; poshz=54;
     }
       if(hatpick>4 && hatpick<9){
       poshh=81*(hatpick-4)-51; poshz=135;
      }

    if(hatpick>8 && hatpick<13){
    poshh=81*(hatpick-8)-51; poshz=216;
     }

       if(hatpick>12 && hatpick<17){
       poshh=81*(hatpick-12)-51; poshz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==8)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS)
      {
     ID_BUTIPOS=hatpick;
     board[hatpick]=9;
     ++seedone;

    if(hatpick<5){
    posih=81*hatpick-51; posiz=54;
     }
       if(hatpick>4 && hatpick<9){
       posih=81*(hatpick-4)-51; posiz=135;
      }

    if(hatpick>8 && hatpick<13){
    posih=81*(hatpick-8)-51; posiz=216;
     }

       if(hatpick>12 && hatpick<17){
       posih=81*(hatpick-12)-51; posiz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==9)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS && hatpick!=ID_BUTIPOS)
      {
     ID_BUTJPOS=hatpick;
     board[hatpick]=10;
     ++seedone;

    if(hatpick<5){
    posjh=81*hatpick-51; posjz=54;
     }
       if(hatpick>4 && hatpick<9){
       posjh=81*(hatpick-4)-51; posjz=135;
      }

    if(hatpick>8 && hatpick<13){
    posjh=81*(hatpick-8)-51; posjz=216;
     }

       if(hatpick>12 && hatpick<17){
       posjh=81*(hatpick-12)-51; posjz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==10)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS && hatpick!=ID_BUTIPOS
     && hatpick!=ID_BUTJPOS)
      {
     ID_BUTKPOS=hatpick;
     board[hatpick]=11;
     ++seedone;

    if(hatpick<5){
    poskh=81*hatpick-51; poskz=54;
     }
       if(hatpick>4 && hatpick<9){
       poskh=81*(hatpick-4)-51; poskz=135;
      }

    if(hatpick>8 && hatpick<13){
    poskh=81*(hatpick-8)-51; poskz=216;
     }

       if(hatpick>12 && hatpick<17){
       poskh=81*(hatpick-12)-51; poskz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==11)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS && hatpick!=ID_BUTIPOS
     && hatpick!=ID_BUTJPOS && hatpick!=ID_BUTKPOS)
      {
     ID_BUTLPOS=hatpick;
     board[hatpick]=12;
     ++seedone;

    if(hatpick<5){
    poslh=81*hatpick-51; poslz=54;
     }
       if(hatpick>4 && hatpick<9){
       poslh=81*(hatpick-4)-51; poslz=135;
      }

    if(hatpick>8 && hatpick<13){
    poslh=81*(hatpick-8)-51; poslz=216;
     }

       if(hatpick>12 && hatpick<17){
       poslh=81*(hatpick-12)-51; poslz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==12)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS && hatpick!=ID_BUTIPOS
     && hatpick!=ID_BUTJPOS && hatpick!=ID_BUTKPOS && hatpick!=ID_BUTLPOS)
      {
     ID_BUTMPOS=hatpick;
     board[hatpick]=13;
     ++seedone;

    if(hatpick<5){
    posmh=81*hatpick-51; posmz=54;
     }
       if(hatpick>4 && hatpick<9){
       posmh=81*(hatpick-4)-51; posmz=135;
      }

    if(hatpick>8 && hatpick<13){
    posmh=81*(hatpick-8)-51; posmz=216;
     }

       if(hatpick>12 && hatpick<17){
       posmh=81*(hatpick-12)-51; posmz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==13)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS && hatpick!=ID_BUTIPOS
     && hatpick!=ID_BUTJPOS && hatpick!=ID_BUTKPOS && hatpick!=ID_BUTLPOS
     && hatpick!=ID_BUTMPOS)
      {
     ID_BUTNPOS=hatpick;
     board[hatpick]=14;
     ++seedone;

    if(hatpick<5){
    posnh=81*hatpick-51; posnz=54;
     }
       if(hatpick>4 && hatpick<9){
       posnh=81*(hatpick-4)-51; posnz=135;
      }

    if(hatpick>8 && hatpick<13){
    posnh=81*(hatpick-8)-51; posnz=216;
     }

       if(hatpick>12 && hatpick<17){
       posnh=81*(hatpick-12)-51; posnz=297;
      }
    }
     }

// ***************************************************************************

    while(seedone==14)
     {
     hatpick=rand() % 16 + 1; //Look for # not yet used before continuing
      
     if(hatpick!=ID_BUTAPOS && hatpick!=ID_BUTBPOS && hatpick!=ID_BUTCPOS
     && hatpick!=ID_BUTDPOS && hatpick!=ID_BUTEPOS && hatpick!=ID_BUTFPOS
     && hatpick!=ID_BUTGPOS && hatpick!=ID_BUTHPOS && hatpick!=ID_BUTIPOS
     && hatpick!=ID_BUTJPOS && hatpick!=ID_BUTKPOS && hatpick!=ID_BUTLPOS
     && hatpick!=ID_BUTMPOS && hatpick!=ID_BUTNPOS)
      {
     ID_BUTOPOS=hatpick;
     board[hatpick]=15;
     ++seedone;

    if(hatpick<5){
    posoh=81*hatpick-51; posoz=54;
     }
       if(hatpick>4 && hatpick<9){
       posoh=81*(hatpick-4)-51; posoz=135;
      }

    if(hatpick>8 && hatpick<13){
    posoh=81*(hatpick-8)-51; posoz=216;
     }

       if(hatpick>12 && hatpick<17){
       posoh=81*(hatpick-12)-51; posoz=297;
      }
    }
     }
       seedone=0; 
    } //END FUNCTION BRACKET

// ***************************************************************************


 void no_Loyds()
  {
  
      int good_pick;
      for (int t=0; t<17; t++)
       {
       board[t]=0;
       }
    // board[16] = 0;

    if(scramble==0)
     {
      srand (time(NULL));
      }

    scramble++; //Global value held so we do not repeat initial seeding -
    
    good_pick=rand() % 24 + 1;
    //++seedone;
    //fstream out("numbers.txt", ios::app);
   // out<<good_pick<<" ";
   // out.close();

   if(good_pick==1)
   {
    board[1]=5;
    poseh=30; posez=54;

    board[2]=6;
    posfh=111; posfz=54;

    board[3]=3;
    posch=192; poscz=54;

    board[4]=14;
    posnh=273; posnz=54;

    board[5]=11;
    poskh=30; poskz=135;

    board[6]=2;
    posbh=111; posbz=135;

    board[7]=7;
    posgh=192; posgz=135;

    board[8]=12;
    poslh=273; poslz=135;
 
    board[9]=9;
    posih=30; posiz=216;

    board[10]=10;
    posjh=111; posjz=216;

    board[11]=13;
    posmh=192; posmz=216;

    board[12]=4;
    posdh=273; posdz=216;

    board[13]=15;
    posoh=30; posoz=297;

    board[14]=8;
    poshh=111; poshz=297;

    board[15]=1;
    posah=192; posaz=297;

    board[16]=0;
   }


   if(good_pick==2)
   {
    board[1]=7;
    posgh=30; posgz=54;

    board[2]=12;
    poslh=111; poslz=54;

    board[3]=11;
    poskh=192; poskz=54;

    board[4]=6;
    posfh=273; posfz=54;

    board[5]=9;
    posih=30; posiz=135;

    board[6]=10;
    posjh=111; posjz=135;

    board[7]=13;
    posmh=192; posmz=135;

    board[8]=2;
    posbh=273; posbz=135;
 
    board[9]=5;
    poseh=30; posez=216;

    board[10]=14;
    posnh=111; posnz=216;

    board[11]=15;
    posoh=192; posoz=216;

    board[12]=8;
    poshh=273; poshz=216;

    board[13]=1;
    posah=30; posaz=297;

    board[14]=4;
    posdh=111; posdz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=0;
   }


   if(good_pick==3)
   {
    board[1]=11;
    poskh=30; poskz=54;

    board[2]=2;
    posbh=111; posbz=54;

    board[3]=3;
    posch=192; poscz=54;

    board[4]=14;
    posnh=273; posnz=54;

    board[5]=5;
    poseh=30; posez=135;

    board[6]=10;
    posjh=111; posjz=135;

    board[7]=1;
    posah=192; posaz=135;

    board[8]=12;
    poslh=273; poslz=135;
 
    board[9]=15;
    posoh=30; posoz=216;

    board[10]=8;
    poshh=111; poshz=216;

    board[11]=9;
    posih=192; posiz=216;

    board[12]=6;
    posfh=273; posfz=216;

    board[13]=13;
    posmh=30; posmz=297;

    board[14]=4;
    posdh=111; posdz=297;

    board[15]=7;
    posgh=192; posgz=297;

    board[16]=0;
   }

   if(good_pick==4)
   {
    board[1]=15;
    posoh=30; posoz=54;

    board[2]=14;
    posnh=111; posnz=54;

    board[3]=9;
    posih=192; posiz=54;

    board[4]=2;
    posbh=273; posbz=54;

    board[5]=1;
    posah=30; posaz=135;

    board[6]=8;
    poshh=111; poshz=135;

    board[7]=11;
    poskh=192; poskz=135;

    board[8]=10;
    posjh=273; posjz=135;
 
    board[9]=13;
    posmh=30; posmz=216;

    board[10]=4;
    posdh=111; posdz=216;

    board[11]=5;
    poseh=192; posez=216;

    board[12]=12;
    poslh=273; poslz=216;

    board[13]=7;
    posgh=30; posgz=297;

    board[14]=6;
    posfh=111; posfz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=0;
   }

   if(good_pick==5)
   {
    board[1]=15;
    posoh=30; posoz=54;

    board[2]=6;
    posfh=111; posfz=54;

    board[3]=9;
    posih=192; posiz=54;

    board[4]=4;
    posdh=273; posdz=54;

    board[5]=1;
    posah=30; posaz=135;

    board[6]=12;
    poslh=111; poslz=135;

    board[7]=5;
    poseh=192; posez=135;

    board[8]=10;
    posjh=273; posjz=135;
 
    board[9]=7;
    posgh=30; posgz=216;

    board[10]=8;
    poshh=111; poshz=216;

    board[11]=3;
    posch=192; poscz=216;

    board[12]=14;
    posnh=273; posnz=216;

    board[13]=13;
    posmh=30; posmz=297;

    board[14]=2;
    posbh=111; posbz=297;

    board[15]=11;
    poskh=192; poskz=297;

    board[16]=0;
   }

   if(good_pick==6)
   {
    board[1]=7;
    posgh=30; posgz=54;

    board[2]=12;
    poslh=111; poslz=54;

    board[3]=13;
    posmh=192; posmz=54;

    board[4]=6;
    posfh=273; posfz=54;

    board[5]=1;
    posah=30; posaz=135;

    board[6]=2;
    posbh=111; posbz=135;

    board[7]=9;
    posih=192; posiz=135;

    board[8]=10;
    posjh=273; posjz=135;
 
    board[9]=5;
    poseh=30; posez=216;

    board[10]=4;
    posdh=111; posdz=216;

    board[11]=3;
    posch=192; poscz=216;

    board[12]=14;
    posnh=273; posnz=216;

    board[13]=15;
    posoh=30; posoz=297;

    board[14]=8;
    poshh=111; poshz=297;

    board[15]=11;
    poskh=192; poskz=297;

    board[16]=0;
   }

   if(good_pick==7)
   {
    board[1]=15;
    posoh=30; posoz=54;

    board[2]=8;
    poshh=111; poshz=54;

    board[3]=11;
    poskh=192; poskz=54;

    board[4]=10;
    posjh=273; posjz=54;

    board[5]=13;
    posmh=30; posmz=135;

    board[6]=14;
    posnh=111; posnz=135;

    board[7]=7;
    posgh=192; posgz=135;

    board[8]=6;
    posfh=273; posfz=135;
 
    board[9]=9;
    posih=30; posiz=216;

    board[10]=4;
    posdh=111; posdz=216;

    board[11]=1;
    posah=192; posaz=216;

    board[12]=12;
    poslh=273; poslz=216;

    board[13]=5;
    poseh=30; posez=297;

    board[14]=2;
    posbh=111; posbz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=0;
   }
   
   if(good_pick==8)
   {
    board[1]=11;
    poskh=30; poskz=54;

    board[2]=2;
    posbh=111; posbz=54;

    board[3]=13;
    posmh=192; posmz=54;

    board[4]=12;
    poslh=273; poslz=54;

    board[5]=9;
    posih=30; posiz=135;

    board[6]=4;
    posdh=111; posdz=135;

    board[7]=7;
    posgh=192; posgz=135;

    board[8]=14;
    posnh=273; posnz=135;
 
    board[9]=1;
    posah=30; posaz=216;

    board[10]=6;
    posfh=111; posfz=216;

    board[11]=15;
    posoh=192; posoz=216;

    board[12]=10;
    posjh=273; posjz=216;

    board[13]=5;
    poseh=30; posez=297;

    board[14]=8;
    poshh=111; poshz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=0;
   }

   if(good_pick==9)
   {
    board[1]=3;
    posch=30; poscz=54;

    board[2]=8;
    poshh=111; poshz=54;

    board[3]=5;
    poseh=192; posez=54;

    board[4]=4;
    posdh=273; posdz=54;

    board[5]=13;
    posmh=30; posmz=135;

    board[6]=12;
    poslh=111; poslz=135;

    board[7]=1;
    posah=192; posaz=135;

    board[8]=14;
    posnh=273; posnz=135;
 
    board[9]=9;
    posih=30; posiz=216;

    board[10]=10;
    posjh=111; posjz=216;

    board[11]=15;
    posoh=192; posoz=216;

    board[12]=6;
    posfh=273; posfz=216;

    board[13]=7;
    posgh=30; posgz=297;

    board[14]=2;
    posbh=111; posbz=297;

    board[15]=11;
    poskh=192; poskz=297;

    board[16]=0;
   } 

   if(good_pick==10)
   {
    board[1]=7;
    posgh=30; posgz=54;

    board[2]=12;
    poslh=111; poslz=54;

    board[3]=11;
    poskh=192; poskz=54;

    board[4]=14;
    posnh=273; posnz=54;

    board[5]=5;
    poseh=30; posez=135;

    board[6]=2;
    posbh=111; posbz=135;

    board[7]=9;
    posih=192; posiz=135;

    board[8]=8;
    poshh=273; poshz=135;
 
    board[9]=15;
    posoh=30; posoz=216;

    board[10]=10;
    posjh=111; posjz=216;

    board[11]=1;
    posah=192; posaz=216;

    board[12]=6;
    posfh=273; posfz=216;

    board[13]=13;
    posmh=30; posmz=297;

    board[14]=4;
    posdh=111; posdz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=0;
   }

   if(good_pick==11)
   {
    board[1]=15;
    posoh=30; posoz=54;

    board[2]=12;
    poslh=111; poslz=54;

    board[3]=5;
    poseh=192; posez=54;

    board[4]=10;
    posjh=273; posjz=54;

    board[5]=3;
    posch=30; poscz=135;

    board[6]=14;
    posnh=111; posnz=135;

    board[7]=9;
    posih=192; posiz=135;

    board[8]=6;
    posfh=273; posfz=135;
 
    board[9]=1;
    posah=30; posaz=216;

    board[10]=2;
    posbh=111; posbz=216;

    board[11]=7;
    posgh=192; posgz=216;

    board[12]=4;
    posdh=273; posdz=216;

    board[13]=13;
    posmh=30; posmz=297;

    board[14]=8;
    poshh=111; poshz=297;

    board[15]=11;
    poskh=192; poskz=297;

    board[16]=0;
   }
   
   if(good_pick==12)
   {
    board[1]=5;
    poseh=30; posez=54;

    board[2]=2;
    posbh=111; posbz=54;

    board[3]=3;
    posch=192; poscz=54;

    board[4]=12;
    poslh=273; poslz=54;

    board[5]=11;
    poskh=30; poskz=135;

    board[6]=4;
    posdh=111; posdz=135;

    board[7]=9;
    posih=192; posiz=135;

    board[8]=10;
    posjh=273; posjz=135;
 
    board[9]=7;
    posgh=30; posgz=216;

    board[10]=14;
    posnh=111; posnz=216;

    board[11]=13;
    posmh=192; posmz=216;

    board[12]=8;
    poshh=273; poshz=216;

    board[13]=15;
    posoh=30; posoz=297;

    board[14]=6;
    posfh=111; posfz=297;

    board[15]=1;
    posah=192; posaz=297;

    board[16]=0;
   } 

   if(good_pick==13)
   {
    board[1]=9;
    posih=30; posiz=54;

    board[2]=2;
    posbh=111; posbz=54;

    board[3]=7;
    posgh=192; posgz=54;

    board[4]=10;
    posjh=273; posjz=54;

    board[5]=3;
    posch=30; poscz=135;

    board[6]=14;
    posnh=111; posnz=135;

    board[7]=5;
    poseh=192; posez=135;

    board[8]=4;
    posdh=273; posdz=135;
 
    board[9]=1;
    posah=30; posaz=216;

    board[10]=12;
    poslh=111; poslz=216;

    board[11]=11;
    poskh=192; poskz=216;

    board[12]=6;
    posfh=273; posfz=216;

    board[13]=13;
    posmh=30; posmz=297;

    board[14]=8;
    poshh=111; poshz=297;

    board[15]=15;
    posoh=192; posoz=297;

    board[16]=0;
   }
    
   if(good_pick==14)
   {
    board[1]=13;
    posmh=30; posmz=54;

    board[2]=6;
    posfh=111; posfz=54;

    board[3]=3;
    posch=192; poscz=54;

    board[4]=8;
    poshh=273; poshz=54;

    board[5]=11;
    poskh=30; poskz=135;

    board[6]=10;
    posjh=111; posjz=135;

    board[7]=15;
    posoh=192; posoz=135;

    board[8]=12;
    poslh=273; poslz=135;
 
    board[9]=9;
    posih=30; posiz=216;

    board[10]=4;
    posdh=111; posdz=216;

    board[11]=1;
    posah=192; posaz=216;

    board[12]=14;
    posnh=273; posnz=216;

    board[13]=5;
    poseh=30; posez=297;

    board[14]=2;
    posbh=111; posbz=297;

    board[15]=7;
    posgh=192; posgz=297;

    board[16]=0;
   }  

   if(good_pick==15)
   {
    board[1]=5;
    poseh=30; posez=54;

    board[2]=8;
    poshh=111; poshz=54;

    board[3]=7;
    posgh=192; posgz=54;

    board[4]=4;
    posdh=273; posdz=54;

    board[5]=13;
    posmh=30; posmz=135;

    board[6]=6;
    posfh=111; posfz=135;

    board[7]=11;
    poskh=192; poskz=135;

    board[8]=10;
    posjh=273; posjz=135;
 
    board[9]=3;
    posch=30; poscz=216;

    board[10]=2;
    posbh=111; posbz=216;

    board[11]=1;
    posah=192; posaz=216;

    board[12]=14;
    posnh=273; posnz=216;

    board[13]=15;
    posoh=30; posoz=297;

    board[14]=12;
    poslh=111; poslz=297;

    board[15]=9;
    posih=192; posiz=297;

    board[16]=0;
   }

   if(good_pick==16)
   {
    board[1]=4;
    posdh=30; posdz=54;

    board[2]=6;
    posfh=111; posfz=54;

    board[3]=10;
    posjh=192; posjz=54;

    board[4]=15;
    posoh=273; posoz=54;

    board[5]=2;
    posbh=30; posbz=135;

    board[6]=13;
    posmh=111; posmz=135;

    board[7]=14;
    posnh=192; posnz=135;

    board[8]=11;
    poskh=273; poskz=135;
 
    board[9]=9;
    posih=30; posiz=216;

    board[10]=7;
    posgh=111; posgz=216;

    board[11]=5;
    poseh=192; posez=216;

    board[12]=3;
    posch=273; poscz=216;

    board[13]=8;
    poshh=30; poshz=297;

    board[14]=1;
    posah=111; posaz=297;

    board[15]=12;
    poslh=192; poslz=297;

    board[16]=0;
   } 
   
   if(good_pick==17)
   {
    board[1]=5;
    poseh=30; posez=54;

    board[2]=6;
    posfh=111; posfz=54;

    board[3]=14;
    posnh=192; posnz=54;

    board[4]=2;
    posbh=273; posbz=54;

    board[5]=8;
    poshh=30; poshz=135;

    board[6]=12;
    poslh=111; poslz=135;

    board[7]=9;
    posih=192; posiz=135;

    board[8]=13;
    posmh=273; posmz=135;
 
    board[9]=15;
    posoh=30; posoz=216;

    board[10]=4;
    posdh=111; posdz=216;

    board[11]=7;
    posgh=192; posgz=216;

    board[12]=11;
    poskh=273; poskz=216;

    board[13]=3;
    posch=30; poscz=297;

    board[14]=10;
    posjh=111; posjz=297;

    board[15]=1;
    posah=192; posaz=297;

    board[16]=0;
   }
   
   if(good_pick==18)
   {
    board[1]=5;
    poseh=30; posez=54;

    board[2]=7;
    posgh=111; posgz=54;

    board[3]=12;
    poslh=192; poslz=54;

    board[4]=13;
    posmh=273; posmz=54;

    board[5]=1;
    posah=30; posaz=135;

    board[6]=4;
    posdh=111; posdz=135;

    board[7]=10;
    posjh=192; posjz=135;

    board[8]=6;
    posfh=273; posfz=135;
 
    board[9]=11;
    poskh=30; poskz=216;

    board[10]=14;
    posnh=111; posnz=216;

    board[11]=8;
    poshh=192; poshz=216;

    board[12]=0;

    board[13]=2;
    posbh=30; posbz=297;

    board[14]=15;
    posoh=111; posoz=297;

    board[15]=9;
    posih=192; posiz=297;

    board[16]=3;
    posch=273,poscz=297;
   }
   
   if(good_pick==19)
   {
    board[1]=7;
    posgh=30; posgz=54;

    board[2]=9;
    posih=111; posiz=54;

    board[3]=14;
    posnh=192; posnz=54;

    board[4]=0;

    board[5]=13;
    posmh=30; posmz=135;

    board[6]=1;
    posah=111; posaz=135;

    board[7]=15;
    posoh=192; posoz=135;

    board[8]=2;
    posbh=273; posbz=135;
 
    board[9]=6;
    posfh=30; posfz=216;

    board[10]=12;
    poslh=111; poslz=216;

    board[11]=10;
    posjh=192; posjz=216;

    board[12]=4;
    posdh=273; posdz=216;

    board[13]=5;
    poseh=30; posez=297;

    board[14]=11;
    poskh=111; poskz=297;

    board[15]=8;
    poshh=192; poshz=297;

    board[16]=3;
    posch=273; poscz=297;
   } 
   
   if(good_pick==20)
   {
    board[1]=10;
    posjh=30; posjz=54;

    board[2]=7;
    posgh=111; posgz=54;

    board[3]=1;
    posah=192; posaz=54;

    board[4]=15;
    posoh=273; posoz=54;

    board[5]=11;
    poskh=30; poskz=135;

    board[6]=12;
    poslh=111; poslz=135;

    board[7]=2;
    posbh=192; posbz=135;

    board[8]=13;
    posmh=273; posmz=135;
 
    board[9]=0;

    board[10]=5;
    poseh=111; posez=216;

    board[11]=8;
    poshh=192; poshz=216;

    board[12]=6;
    posfh=273; posfz=216;

    board[13]=9;
    posih=30; posiz=297;

    board[14]=3;
    posch=111; poscz=297;

    board[15]=4;
    posdh=192; posdz=297;

    board[16]=14;
    posnh=273; posnz=297;
   }

   if(good_pick==21)
   {
    board[1]=0;

    board[2]=14;
    posnh=111; posnz=54;

    board[3]=3;
    posch=192; poscz=54;

    board[4]=12;
    poslh=273; poslz=54;

    board[5]=15;
    posoh=30; posoz=135;

    board[6]=11;
    poskh=111; poskz=135;

    board[7]=4;
    posdh=192; posdz=135;

    board[8]=2;
    posbh=273; posbz=135;
 
    board[9]=10;
    posjh=30; posjz=216;

    board[10]=5;
    poseh=111; posez=216;

    board[11]=9;
    posih=192; posiz=216;

    board[12]=8;
    poshh=273; poshz=216;

    board[13]=6;
    posfh=30; posfz=297;

    board[14]=13;
    posmh=111; posmz=297;

    board[15]=1;
    posah=192; posaz=297;

    board[16]=7;
    posgh=273; posgz=297;
   }

   if(good_pick==22)
   {
    board[1]=9;
    posih=30; posiz=54;

    board[2]=12;
    poslh=111; poslz=54;

    board[3]=10;
    posjh=192; posjz=54;

    board[4]=6;
    posfh=273; posfz=54;

    board[5]=0;

    board[6]=7;
    posgh=111; posgz=135;

    board[7]=2;
    posbh=192; posbz=135;

    board[8]=3;
    posch=273; poscz=135;
 
    board[9]=11;
    poskh=30; poskz=216;

    board[10]=1;
    posah=111; posaz=216;

    board[11]=4;
    posdh=192; posdz=216;

    board[12]=13;
    posmh=273; posmz=216;

    board[13]=5;
    poseh=30; posez=297;

    board[14]=15;
    posoh=111; posoz=297;

    board[15]=8;
    poshh=192; poshz=297;

    board[16]=14;
    posnh=273; posnz=297;
   }

   if(good_pick==23)
   {
    board[1]=12;
    poslh=30; poslz=54;

    board[2]=14;
    posnh=111; posnz=54;

    board[3]=13;
    posmh=192; posmz=54;

    board[4]=8;
    poshh=273; poshz=54;

    board[5]=6;
    posfh=30; posfz=135;

    board[6]=1;
    posah=111; posaz=135;

    board[7]=4;
    posdh=192; posdz=135;

    board[8]=7;
    posgh=273; posgz=135;
 
    board[9]=5;
    poseh=30; posez=216;

    board[10]=15;
    posoh=111; posoz=216;

    board[11]=0;

    board[12]=11;
    poskh=273; poskz=216;

    board[13]=9;
    posih=30; posiz=297;

    board[14]=10;
    posjh=111; posjz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=2;
    posbh=273; posbz=297;
   }

   if(good_pick==24)
   {
    board[1]=12;
    poslh=30; poslz=54;

    board[2]=14;
    posnh=111; posnz=54;

    board[3]=13;
    posmh=192; posmz=54;

    board[4]=8;
    poshh=273; poshz=54;

    board[5]=6;
    posfh=30; posfz=135;

    board[6]=1;
    posah=111; posaz=135;

    board[7]=4;
    posdh=192; posdz=135;

    board[8]=7;
    posgh=273; posgz=135;
 
    board[9]=5;
    poseh=30; posez=216;

    board[10]=15;
    posoh=111; posoz=216;

    board[11]=0;

    board[12]=11;
    poskh=273; poskz=216;

    board[13]=9;
    posih=30; posiz=297;

    board[14]=10;
    posjh=111; posjz=297;

    board[15]=3;
    posch=192; poscz=297;

    board[16]=2;
    posbh=273; posbz=297;
   }

   if(good_pick==25)
   {
    board[1]=14;
    posnh=30; posnz=54;

    board[2]=0;

    board[3]=1;
    posah=192; posaz=54;

    board[4]=10;
    posjh=273; posjz=54;

    board[5]=7;
    posgh=30; posgz=135;

    board[6]=9;
    posih=111; posiz=135;

    board[7]=6;
    posfh=192; posfz=135;

    board[8]=5;
    poseh=273; posez=135;
 
    board[9]=3;
    posch=30; poscz=216;

    board[10]=8;
    poshh=111; poshz=216;

    board[11]=2;
    posbh=192; posbz=216;

    board[12]=4;
    posdh=273; posdz=216;

    board[13]=13;
    posmh=30; posmz=297;

    board[14]=12;
    poslh=111; poslz=297;

    board[15]=11;
    poskh=192; poskz=297;

    board[16]=15;
    posoh=273; posoz=297;
   }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
  }
  
  
