#include "mainHeader.h"
#include "resource.h"
#include "sounds.h"
#include <stdlib.h>
#include <cstring>

#include <commctrl.h>
//#pragma comment(lib,"winmm.lib")
#include <mmsystem.h>


LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

//HWND hEndGame;
char szClassName[ ] = "15_Slider Puzzle";
static RECT titleRect  = { 0, 0, 540, 25  };
const int ID_TIMER = 1;
int ticktock=0;
int mincount=0;
int halttick=1;
int xmasbell=0;

int WINAPI
WinMain (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nCmdShow)

{

     char Path[MAX_PATH];    /* Default Size - GetCurDirect */
     GetModuleFileName(NULL, Path, MAX_PATH);
     getDrivePath=Path;
     std::string::size_type loc2= getDrivePath.find_last_of("\\");
     getDrivePath.erase(loc2+1);   /* Retain full pathway  */

     RestoreBmp=getDrivePath;
     
     DatFilePath=getDrivePath;
     DatFilePath+="stats.txt";
     RestoreBmp+="BmpImages\\";  //restore bitmap
     myimage=RestoreBmp;
     myimage+="PuzNumbs.bmp";
     
     finalpath=RestoreBmp;
     finalpath+="game_image00.bmp";
     //std::strcpy (pngs,finalpath.c_str());
	// pngs="game_imagealt.bmp";

     HelpFiler=getDrivePath;
     HelpFiler.append("15_sliders-help.chm"); /* help file */
     
     
    CopyFile(myimage.c_str(), finalpath.c_str(),false);
     

     setarray();

    pngs=strdup(finalpath.c_str());


    MSG messages;
    WNDCLASSEX wincl;
    //HDC hdc;

    HBITMAP hsliders=NULL;
    
    hsliders=reinterpret_cast<HBITMAP>(LoadImage(hThisInstance,
    MAKEINTRESOURCE(IDI_MAINSKIN),
    IMAGE_BITMAP,0,0,
    LR_CREATEDIBSECTION));

    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = (HICON)LoadImage(GetModuleHandle(NULL),
    MAKEINTRESOURCE(IDI_SMLCON), IMAGE_ICON, 16, 16, 0);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = CreatePatternBrush(hsliders);
    DeleteObject(hsliders);

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    //the parent window
    int Left=GetSystemMetrics(SM_CXSCREEN)/2;
    int Top=GetSystemMetrics(SM_CYSCREEN)/2;    
    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0, 
           szClassName,
           "15_Slider Puzzle",
           WS_POPUPWINDOW&~WS_THICKFRAME&~WS_BORDER,
           Left-420,
           Top-190,    
           742, 
           451,
           HWND_DESKTOP,
           NULL,
           hThisInstance,
           NULL
           );


/* Our Main control buttons */
    hGame = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     150, 393, 95, 40,
    hwnd, (HMENU) IDB_GAME, GetModuleHandle (NULL), NULL);
    
    hLoader = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     402, 337, 95, 40,
    hwnd, (HMENU) IDB_LOAD, GetModuleHandle (NULL), NULL); 
    
    hCancel = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     402, 287, 95, 40,
    hwnd, (HMENU) IDB_CANCEL, GetModuleHandle (NULL), NULL); 
    
    hHelper = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     690, 5, 23, 18,
    hwnd, (HMENU) IDB_HELP, GetModuleHandle (NULL), NULL);
    
    hMinimize = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     664, 5, 24, 18,
    hwnd, (HMENU) IDB_MINIMIZE, GetModuleHandle (NULL), NULL);
    
    hCloseOut = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     715, 5, 23, 18,
    hwnd, (HMENU) IDB_CLOSE, GetModuleHandle (NULL), NULL); 
    
    hMsPaint = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     700, 414, 28, 28,
    hwnd, (HMENU) IDB_MSPAINT, GetModuleHandle (NULL), NULL);
    
    
    hAudioOff = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     700, 414, 28, 28,
    hwnd, (HMENU) IDB_AUDIOFF, GetModuleHandle (NULL), NULL);
    
    ShowWindow(hAudioOff,SW_HIDE);
    
        
    hAccept = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     481, 52, 12, 12,
    hwnd, (HMENU) IDB_ACCEPT, GetModuleHandle (NULL), NULL); 

    hDecline = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     481, 52, 12, 12,
    hwnd, (HMENU) IDB_DECLINE, GetModuleHandle (NULL), NULL);    
    ShowWindow (hAccept, SW_HIDE);  
                                                                                                                                      
    //Our buttons which are actually our game blocks
    gamePiece[1] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     30, 54, 80, 80,
    hwnd, (HMENU) IDB_BUTTON1, GetModuleHandle (NULL), NULL); 

    gamePiece[2] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     111, 54, 80, 80,
    hwnd, (HMENU) IDB_BUTTON2, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[3] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     192, 54, 80, 80,
    hwnd, (HMENU) IDB_BUTTON3, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[4] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     273, 54, 80, 80,
    hwnd, (HMENU) IDB_BUTTON4, GetModuleHandle (NULL), NULL); 
    
    gamePiece[5] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     30, 135, 80, 80,
    hwnd, (HMENU) IDB_BUTTON5, GetModuleHandle (NULL), NULL); 

    gamePiece[6] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     111, 135, 80, 80,
    hwnd, (HMENU) IDB_BUTTON6, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[7] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     192, 135, 80, 80,
    hwnd, (HMENU) IDB_BUTTON7, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[8] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     273, 135, 80, 80,
    hwnd, (HMENU) IDB_BUTTON8, GetModuleHandle (NULL), NULL);  
       
    gamePiece[9] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     30, 216, 80, 80,
    hwnd, (HMENU) IDB_BUTTON9, GetModuleHandle (NULL), NULL); 

    gamePiece[10] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     111, 216, 80, 80,
    hwnd, (HMENU) IDB_BUTTON10, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[11] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     192, 216, 80, 80,
    hwnd, (HMENU) IDB_BUTTON11, GetModuleHandle (NULL), NULL); 
   // ShowWindow (hwnd, nCmdShow);
    
    gamePiece[12] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     273, 216, 80, 80,
    hwnd, (HMENU) IDB_BUTTON12, GetModuleHandle (NULL), NULL);

    gamePiece[13] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     30, 297, 80, 80,
    hwnd, (HMENU) IDB_BUTTON13, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[14] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     111, 297, 80, 80,
    hwnd, (HMENU) IDB_BUTTON14, GetModuleHandle (NULL), NULL); 
    //ShowWindow (hwnd, nCmdShow);
    
    gamePiece[15] = CreateWindowEx(0,TEXT("BUTTON"),TEXT(""),                   
    WS_CHILD| WS_VISIBLE |BS_OWNERDRAW,
     192, 297, 80, 80,
    hwnd, (HMENU) IDB_BUTTON15, GetModuleHandle (NULL), NULL);
    
     hDisplay = CreateWindowEx(0,TEXT("STATIC"),TEXT(""),
    WS_CHILD| WS_VISIBLE |SS_BITMAP,
     548, 28, 190, 182,
    hwnd, (HMENU) IDB_DISPLAY, GetModuleHandle (NULL), NULL);
    

    
 
    HDC hdc_player2=NULL;
    char* temppath=strdup(finalpath.c_str());
    BITMAP bm;

	
	LoadAnImage(temppath); 
	SendMessage(hDisplay,(UINT)STM_SETIMAGE,
    (WPARAM)IMAGE_BITMAP,(LPARAM)hBB);
	

      GetObject(hBB,sizeof(bm),&bm);
      HDC memDC_ply2 = CreateCompatibleDC ( hdc_player2 );
      HBITMAP hBB = CreateCompatibleBitmap (hdc_player2, 0, 0);
       

      SelectObject ( memDC_ply2, hBB ); 
      DeleteDC(memDC_ply2);
      DeleteObject(hBB);
	  
	  free(temppath); 
       
 ///////////////////////////////////////////////////////////////////   
    
    hGTime = CreateWindowEx(0,TEXT("STATIC"),TEXT(""),                      
    WS_CHILD| WS_VISIBLE | SS_SIMPLE|SS_NOPREFIX, 436, 117, 48, 20, hwnd,
    (HMENU) IDS_SHOWTIME, GetModuleHandle(NULL), NULL);
    
    SetDlgItemText((HWND)hwnd,IDS_SHOWTIME,"0:00");
    
    hGMoves = CreateWindowEx(0,TEXT("STATIC"),TEXT(""),                      
    WS_CHILD| WS_VISIBLE | SS_SIMPLE|SS_NOPREFIX, 436, 184, 38, 20, hwnd,
    (HMENU)  IDS_MOVES, GetModuleHandle(NULL), NULL);
    
    SetDlgItemText((HWND)hwnd,IDS_MOVES,"0");
    
    hGResult = CreateWindowEx(0,TEXT("STATIC"),TEXT(""),                      
    WS_CHILD| WS_VISIBLE | SS_CENTER, 410, 252, 80, 20, hwnd,
    (HMENU)  IDS_RESULT, GetModuleHandle(NULL), NULL);
    
    SendMessage(hGResult, WM_SETFONT,(WPARAM)
    GetStockObject(DEFAULT_GUI_FONT), true);
          
    hshowtime = CreateWindowEx(0,TEXT("STATIC"),TEXT(""),                      
    WS_CHILD| WS_VISIBLE | SS_CENTER, 676, 364, 36, 16, hwnd,
    (HMENU)  IDS_PYRTIME, GetModuleHandle(NULL), NULL);
    
    SendMessage(hshowtime, WM_SETFONT,(WPARAM)
    GetStockObject(DEFAULT_GUI_FONT), true); 


    hshowmove = CreateWindowEx(0,TEXT("STATIC"),TEXT(""),                      
    WS_CHILD| WS_VISIBLE | SS_CENTER, 676, 387, 36, 16, hwnd,
    (HMENU)  IDS_PYRMOVE, GetModuleHandle(NULL), NULL);
    
    SendMessage(hshowmove, WM_SETFONT,(WPARAM)
    GetStockObject(DEFAULT_GUI_FONT), true); 
    

           
    loadstats();
    
    playhours+=":";
    playhours+=playsecos;
    
    SetDlgItemText((HWND)hwnd,IDS_PYRTIME,playhours.c_str());
    SetDlgItemText((HWND)hwnd,IDS_PYRMOVE,playmoves.c_str());
       
    ShowWindow (hwnd, nCmdShow);
        
    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }

    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK
WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;

    switch (message)
    {
        case WM_DESTROY:
            PostQuitMessage (0);
            break;
            
        case WM_LBUTTONDOWN:
         {
            
            POINT pt = { LOWORD(lParam), HIWORD(lParam) };
            if ( PtInRect(&titleRect, pt)){
            SendMessage(hwnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam) ;
            return 0 ;
            }
           }
            break; 

        case WM_CTLCOLORSTATIC: 
                {
                HDC dcc = (HDC)wParam;
                SetTextColor( dcc, RGB(0,0,0)); 
                SetBkMode(dcc, TRANSPARENT);
                return (int)(HBRUSH)GetStockObject(TRANSPARENT);
                DeleteDC(dcc);
            break;   
                }
                break;
                
        case WM_TIMER:
      		 {
      		 tempcount.erase();
      		 if(mincount==59&&ticktock==59){
      		 halttick=1;
      		 SetDlgItemText((HWND)hwnd,IDS_RESULT,"Time's up!");
      		 KillTimer(hwnd,ID_TIMER);
      		 gameRunning=0;
      		 }
      		 
      		  if(halttick==0){
    	       std::string showcount;
               std::stringstream seccount;
               ticktock++;
     
             if(ticktock<10&&mincount==0){
              seccount<<"0:0";
              seccount<<ticktock;
              showcount=seccount.str();
              }
             if(ticktock<10&&mincount>0){
              seccount<<mincount;
              seccount<<":0";
              seccount<<ticktock;
              showcount=seccount.str();
              }
             if(ticktock>9&& ticktock<60 &&mincount==0){
              seccount<<"0:";
              seccount<<ticktock;
              showcount=seccount.str();
              }
              
              if(ticktock>9&& ticktock<60 &&mincount>0){
              seccount<<mincount<<":";
              seccount<<ticktock;
              showcount=seccount.str();
              }
             
             if(ticktock>59){
              mincount++;
              seccount<<mincount;
              seccount<<":00";
              ticktock=0;
              showcount=seccount.str();
             }
             tempcount=showcount;
             SetDlgItemText((HWND)hwnd,IDS_SHOWTIME,showcount.c_str());
              }
               }  
    		 break;      
            
        case WM_DRAWITEM:
            {
            DRAWITEMSTRUCT* lpDrawItem=(DRAWITEMSTRUCT*)lParam;
            HBITMAP hBmp=NULL;

            if (lpDrawItem->itemState&ODS_SELECTED)
            {
          
            if (LOWORD(wParam)==IDB_GAME)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_GAMEDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }
            
            else if (LOWORD(wParam)==IDB_LOAD)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_BMPDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }
            
            else if (LOWORD(wParam)==IDB_CANCEL)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_CANDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }
                        
            else if (LOWORD(wParam)==IDB_HELP)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_HELPDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            } 
            
            else if (LOWORD(wParam)==IDB_MINIMIZE)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_MINDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }
            
            else if (LOWORD(wParam)==IDB_ACCEPT)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_NOTRY),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));
            }
          
            else if (LOWORD(wParam)==IDB_DECLINE)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_DOTRY),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));
            }               
            
            else if (LOWORD(wParam)==IDB_CLOSE)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_CLOSEDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }
            
            else if (LOWORD(wParam)==IDB_MSPAINT)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_PAINTUP),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }
            
            else if (LOWORD(wParam)==IDB_AUDIOFF)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            MAKEINTRESOURCE(IDI_PAINTDN),
            IMAGE_BITMAP,0,0,
            LR_CREATEDIBSECTION));                           
            }            
                        
            else if (LOWORD(wParam)==IDB_BUTTON1)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON2)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            }
             
            else if (LOWORD(wParam)==IDB_BUTTON3)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON4)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            }
                                                                                                                                       
            else if (LOWORD(wParam)==IDB_BUTTON5)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON6)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            }
             
            else if (LOWORD(wParam)==IDB_BUTTON7)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON8)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON9)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON10)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            }
             
            else if (LOWORD(wParam)==IDB_BUTTON11)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON12)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 

            else if (LOWORD(wParam)==IDB_BUTTON13)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            }
             
            else if (LOWORD(wParam)==IDB_BUTTON14)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            } 
            
            else if (LOWORD(wParam)==IDB_BUTTON15)
            {
            hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
            myimage.c_str(),
            IMAGE_BITMAP,0,0,
            LR_LOADFROMFILE));                           
            }                                          
           }
             
         else
          {
         if (LOWORD(wParam)==IDB_GAME){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_GAMEUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }
          
         if (LOWORD(wParam)==IDB_LOAD){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_BMPUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          } 
          
         if (LOWORD(wParam)==IDB_CANCEL){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_CANUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          } 
                    
         if (LOWORD(wParam)==IDB_HELP){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_HELPUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }
          
         if (LOWORD(wParam)==IDB_MINIMIZE){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_MINUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }
          
         if (LOWORD(wParam)==IDB_ACCEPT){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_NOTRY),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }
          
         if (LOWORD(wParam)==IDB_DECLINE){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_DOTRY),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }                     
          
         if (LOWORD(wParam)==IDB_CLOSE){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_CLOSEUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          } 

         if (LOWORD(wParam)==IDB_MSPAINT){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_PAINTUP),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }
          
         if (LOWORD(wParam)==IDB_AUDIOFF){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         MAKEINTRESOURCE(IDI_PAINTDN),
         IMAGE_BITMAP,0,0,
         LR_CREATEDIBSECTION));
          }          
                     
          if (LOWORD(wParam)==IDB_BUTTON1){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON2){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          } 
          
          if (LOWORD(wParam)==IDB_BUTTON3){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON4){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          } 
          
          if (LOWORD(wParam)==IDB_BUTTON5){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON6){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          } 
          
          if (LOWORD(wParam)==IDB_BUTTON7){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON8){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          } 
            
          if (LOWORD(wParam)==IDB_BUTTON9){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON10){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          } 
          
          if (LOWORD(wParam)==IDB_BUTTON11){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON12){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }

          if (LOWORD(wParam)==IDB_BUTTON13){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          } 
          
          if (LOWORD(wParam)==IDB_BUTTON14){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }
          
          if (LOWORD(wParam)==IDB_BUTTON15){
         hBmp=reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle(0),
         myimage.c_str(),
         IMAGE_BITMAP,0,0,
         LR_LOADFROMFILE));
          }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
         }
         
        BITMAP bm;
        GetObject(hBmp,sizeof(bm),&bm);
        
        int width2=bm.bmWidth/4;
        int width3=bm.bmWidth/2;
        int width4=bm.bmWidth-bm.bmWidth/4;
    
        int height2=bm.bmHeight/4;
        int height3=bm.bmHeight/2;
        int height4=bm.bmHeight-bm.bmHeight/4;
    
        HDC hMemDC=CreateCompatibleDC(NULL);
        HBITMAP hOldBmp=(HBITMAP)SelectObject(hMemDC,hBmp);
        
         if(LOWORD(wParam)==IDB_BUTTON1){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  0,0,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   } 
                   
       else if(LOWORD(wParam)==IDB_BUTTON2){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width2,0,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
                                             
      else if(LOWORD(wParam)==IDB_BUTTON3){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width3, 0,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
                   
      else if(LOWORD(wParam)==IDB_BUTTON4){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width4,0,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   } 

      else if(LOWORD(wParam)==IDB_BUTTON5){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  0,height2,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
                   
      else if(LOWORD(wParam)==IDB_BUTTON6){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width2,height2,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   } 
                                
      else if(LOWORD(wParam)==IDB_BUTTON7){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width3,height2,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }

      else if(LOWORD(wParam)==IDB_BUTTON8){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width4,height2,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
     else if(LOWORD(wParam)==IDB_BUTTON9){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  0,height3,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
                    
      else if(LOWORD(wParam)==IDB_BUTTON10){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width2,height3,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   } 
                   
      else if(LOWORD(wParam)==IDB_BUTTON11){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width3,height3,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   } 
                   
      else if(LOWORD(wParam)==IDB_BUTTON12){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width4,height3,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }  
                   
      else if(LOWORD(wParam)==IDB_BUTTON13){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  0,height4,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   } 
                   
      else if(LOWORD(wParam)==IDB_BUTTON14){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width2,height4,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
                   
      else if(LOWORD(wParam)==IDB_BUTTON15){
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  width3,height4,
                  bm.bmWidth=bm.bmWidth/4,
                  bm.bmHeight=bm.bmHeight/4,
                  SRCCOPY);
                   }
                                                              
        else {
        SetStretchBltMode(lpDrawItem->hDC,HALFTONE); 
        StretchBlt( lpDrawItem->hDC,
                  lpDrawItem->rcItem.left,
                  lpDrawItem->rcItem.top,
                  lpDrawItem->rcItem.right-lpDrawItem->rcItem.left, 
                  lpDrawItem->rcItem.bottom-lpDrawItem->rcItem.top,
                  hMemDC,
                  0,0,
                  bm.bmWidth,
                  bm.bmHeight,
                  SRCCOPY);
                   }     
        SelectObject(hMemDC,hOldBmp);
        DeleteDC(hMemDC);
        DeleteObject(hBmp); 
        }
        break;
        
        case WM_PAINT:
		    {
 			RECT rcClient;
			PAINTSTRUCT ps;
			hdc = BeginPaint(hwnd, &ps);
			GetClientRect(hwnd, &rcClient);
			EndPaint(hwnd, &ps);
            }
            break; 
                        
        case WM_COMMAND:
            {
            
        switch(LOWORD(wParam))
			{
			
            case IDB_CLOSE:
               if(gameRunning==1){
              KillTimer(hwnd,ID_TIMER);
               }            
              DestroyWindow(hwnd);
              break;

            case IDB_MINIMIZE:
              playwav2();
              ShowWindow(hwnd,SW_MINIMIZE);
              break;
            
            case IDB_HELP:
              helpload();
              break;
            
            case IDB_ACCEPT:
              is_Challenge=0;
              ShowWindow(hDecline,SW_SHOW);
              ShowWindow(hAccept, SW_HIDE);
              break;
            
            case IDB_DECLINE:
              is_Challenge=1;
              ShowWindow(hAccept, SW_SHOW);
              ShowWindow(hDecline,SW_HIDE);
              break;

                    
            case IDB_LOAD:
             if(gameRunning==0){
              playwav1();
 
////////////////////////////////////////////////////////              
               LoadPic();
  
      
    BITMAP bm;
    HDC hdc_player2=NULL;
     //MessageBox(NULL,ifpng.c_str(),NULL,MB_OK);

     if(ifpng=="png" || ifpng=="PNG")
      {
      LoadAnImage(pngs);
      ifpng.erase(); 
      }
 
     else {
	
    char* temppath2=strdup(myimage.c_str()); 
	LoadAnImage(temppath2); 
     }
	
	
	SendMessage(hDisplay,(UINT)STM_SETIMAGE,
    (WPARAM)IMAGE_BITMAP,(LPARAM)hBB);
	

      GetObject(hBB,sizeof(bm),&bm);
      HDC memDC_ply2 = CreateCompatibleDC ( hdc_player2 );
      HBITMAP hBB = CreateCompatibleBitmap (hdc_player2, 0, 0);
       

      SelectObject ( memDC_ply2, hBB ); 
      DeleteDC(memDC_ply2);
      DeleteObject(hBB);
                   
          
          // InvalidateRect((HWND)hDisplay,NULL,false);
         //  UpdateWindow(hDisplay); 
         //  CaptureWindow (hDisplay);
           
          if(blah!="BMP"||blah!="bmp"){
           InvalidateRect((HWND)hDisplay,NULL,false);
           UpdateWindow(hDisplay); 
           CaptureWindow (hDisplay);
          myimage.erase();
          myimage=finalpath;
          }
           
            InvalidateRect((HWND)hwnd,NULL,false);
           UpdateWindow(hwnd);        
              
              
              
              
/////////////////////////////////////////////////////////              
             if(clowntime=="clown.bmp"){
               playwav9();
                clowntime.erase();
               }
              
             else if(clowntime=="xmasbells.bmp"){
                xmasbell=1;
                }
                
             else if(clowntime=="santa.bmp"){
                xmasbell=2;
                 }
                 
                else{
                 xmasbell=0;
                 }
              }
               else {
                MessageBeep(0);
                }
              break;
 
            case IDB_BUTTON1:
             if(gameRunning==1){
              LetterA();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }
               
                else {
                 MessageBeep(0);
                 }                 
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                
              }
              break;
            
            case IDB_BUTTON2:
             if(gameRunning==1){
              LetterB();
              
               if(QuikMove==1){
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }
               
                else {
                 MessageBeep(0);
                 }                 
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                          
              }
              break;
              
            case IDB_BUTTON3:
             if(gameRunning==1){
              LetterC();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }
               
                else {
                 MessageBeep(0);
                 }                 
               
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                          
              }
              break;
              
            case IDB_BUTTON4:
             if(gameRunning==1){
              LetterD();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////  
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str()); 
               }
               
                else {
                 MessageBeep(0);
                 }                 
               
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                          
              }
              break;
              
            case IDB_BUTTON5:
             if(gameRunning==1){
              LetterE();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////  
				   
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }
               
                else {
                 MessageBeep(0);
                 }                 
               
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                           
              }
              break;
            
            case IDB_BUTTON6:
             if(gameRunning==1){
              LetterF();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////  
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }


                else {
                 MessageBeep(0);
                 }                 
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                          
              }
              break;
            
            case IDB_BUTTON7:
             if(gameRunning==1){
              LetterG();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
				   
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }

                else {
                 MessageBeep(0);
                 }                 
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                            
              }
              break;
             
            case IDB_BUTTON8:
             if(gameRunning==1){
              LetterH();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////  
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
               }


                else {
                 MessageBeep(0);
                 }                 
///////////////////MAGIC SQUARE CODE /////////////////////////////////
              checkWin();
              
             if(gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              
              playwav5();
               
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
               }            
               
///////////////////////////////////////////////////////////////////////                            
              }
              break;
                    
            case IDB_BUTTON9:
             if(gameRunning==1){
              LetterI();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////  
				   
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 && gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
             // gameWon=0;
              
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
               
              if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
              gameWon=0;
                }
                
               }
             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               }
              }
               else {
                MessageBeep(0);
                }                                         
              }
              break;
            
            case IDB_BUTTON10:
             if(gameRunning==1){
              LetterJ();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 || gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
             // gameWon=0;
              
              if(xmasbell==2){
                playwav8();
                 }
                 else{
              playwav5();
               }
               
              if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
              gameWon=0;
                }
               }
               
               
             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               }
              }
               else {
                MessageBeep(0);
                }                                          
              }
              break;
            
            case IDB_BUTTON11:
             if(gameRunning==1){
              LetterK();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 || gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              //gameWon=0;
              
              if(xmasbell==2){
                playwav8();
                 }
                 else{
              playwav5();
               }
               
               if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
              gameWon=0;
                }
               }
                     
               
             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               } 
              }
               else {
                MessageBeep(0);
                }                                         
              }
              break;
            
            case IDB_BUTTON12:
             if(gameRunning==1){
              LetterL();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 || gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
             // gameWon=0;
              
////////////////////////////////////////////////////////////////////////////////

              highscores();
              int totalusup=mincount*60+ticktock;
              int lastchamp=bestminute*60+bestsecond;
              
              bestminute=mincount;
              bestsecond=ticktock;
              bestmove=movenumber;
              
               if(totalusup<lastchamp){
                newstats();
                
                if(cheers==1){
                playwav10();
                }
                
                std::ostringstream ass;
                 if(ticktock>9){
                ass<<bestminute<<":"<<ticktock;
                 }
                 else{
                ass<<bestminute<<":"<<"0"<<ticktock;
                 }
                playhours.erase();
                playhours=ass.str();
                SetDlgItemText((HWND)hwnd,IDS_PYRTIME,playhours.c_str());
                std::ostringstream bss;
                bss<<movenumber;
                playmoves.erase();
                playmoves=bss.str();
                SetDlgItemText((HWND)hwnd,IDS_PYRMOVE,playmoves.c_str());
               }
              
////////////////////////////////////////////////////////////////////////////////              
              if(xmasbell==2){
                playwav8();
                 }
                 else{
               if(totalusup>lastchamp ||cheers==0){
              playwav5();
                }
               }
               
               if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
              gameWon=0;
                }
               }
             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               }
              }
               else{
                MessageBeep(0);
                }              
              }
              break;
                      
            case IDB_BUTTON13:
             if(gameRunning==1){
              LetterM();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
				   
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 || gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
             // gameWon=0;
              
              if(xmasbell==2){
                playwav8();
                 }
                 else{
              playwav5();
               }
               
               if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
                }
              gameWon=0;  
               }

             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               }
              }
               else{
                MessageBeep(0);
                }              
              }
              break;
              
            case IDB_BUTTON14:
             if(gameRunning==1){
              LetterN();
               if(QuikMove==1){
               
////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
/////////////////////////////////////////////////  
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 || gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              //gameWon=0;
              
              if(xmasbell==2){
                playwav8();
                 }
                 else{
              playwav5();
               }
               
               if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
              gameWon=0;
                }
               }
                          
               
             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               } 
              }
               else{
                MessageBeep(0);
                }              
              }
              break;
                
            case IDB_BUTTON15:
             if(gameRunning==1){
              LetterO();
               if(QuikMove==1){
               
 ////////////////////////////////////////////////
             if(mutecntl%2==0)
			   {             
                if(xmasbell==0 || xmasbell==2){
                 playwav3(); 
                 }
                else{
                 playwav7();
                  }
                }
///////////////////////////////////////////////// 
                  
              movenumber++;
              IntToString(movenumber);
              SetDlgItemText((HWND)hwnd,IDS_MOVES,gameCount.c_str());
              
              checkWin();
             if(gameWon==1 || gameWon==3 && is_magic==1){
              KillTimer(hwnd,ID_TIMER);
              //gameWon=0;
              
              highscores();
              int totalusup7=mincount*60+ticktock;
              int lastchamp7=bestminute*60+bestsecond;
              
              bestminute=mincount;
              bestsecond=ticktock;
              bestmove=movenumber;
              
               if(totalusup7<lastchamp7){
                newstats();
                if(cheers==1)
                 {
                 playwav10();
                 }
                
                std::ostringstream nss;
                 if(ticktock>9){
                nss<<bestminute<<":"<<ticktock;
                 }
                 else{
                nss<<bestminute<<":"<<"0"<<ticktock;
                 }
                playhours.erase();
                playhours=nss.str();
                SetDlgItemText((HWND)hwnd,IDS_PYRTIME,playhours.c_str());
                std::ostringstream mss;
                mss<<movenumber;
                playmoves.erase();
                playmoves=mss.str();
                SetDlgItemText((HWND)hwnd,IDS_PYRMOVE,playmoves.c_str());
               }
              
               if(xmasbell==2){
                playwav8();
                 }
                 else{
                 if(cheers==0){
                   playwav5();
                  }
                 else{
                  playwav10();
                 }
              
               }
               if(gameWon==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Solved");
              gameWon=0;
                }
               
               if(gameWon==3 && is_magic==1)
                {
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Magic Square");
              gameWon=0;
                }
               }
             if(gameWon==2){
              KillTimer(hwnd,ID_TIMER);
              gameWon=0;
              playwav4();
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Unsolvable");
               }
              }
               else {
                MessageBeep(0);
                }             
              }
              break;
            
            case IDB_CANCEL:
             if(gameRunning==1){
              playwav1();
              KillTimer(hwnd,ID_TIMER);
              gameRunning = 0;
              gameWon = 0;
              SetDlgItemText((HWND)hwnd,IDS_RESULT,"Canceled");
              }
               else{
               MessageBeep(0);
                }
              break;
              
            case IDB_MSPAINT:
              {
               playwav1();
               mutecntl++;
               ShowWindow(hMsPaint,false);
               ShowWindow(hAudioOff,true);
                }
               break;
               
             case IDB_AUDIOFF:
              {
               playwav1();
               mutecntl++;
               ShowWindow(hMsPaint,true);
               ShowWindow(hAudioOff,false);
                }
               break;
              
            case IDB_GAME:
             {
              if(gameRunning==0)
              {
               playwav6();
   	           mincount=0;
               ticktock=0;
               halttick=0;
               SetTimer(hwnd, ID_TIMER, 1000, NULL);  
               movenumber=0;
               gameRunning=1;
               SetDlgItemText((HWND)hwnd,IDS_MOVES,"0");
               SetDlgItemText((HWND)hwnd,IDS_SHOWTIME,"0:00");
               SetDlgItemText((HWND)hwnd,IDS_RESULT," ");
               
               if(is_Challenge==1){
               fillboard(); //Reset vector & hndl array
               }
               if(is_Challenge==0) {
               no_Loyds();
                }
               
               MoveWindow(gamePiece[1], posah, posaz, 80, 80, true);
               MoveWindow(gamePiece[2], posbh, posbz, 80, 80, true);
               MoveWindow(gamePiece[3], posch, poscz, 80, 80, true);
               MoveWindow(gamePiece[4], posdh, posdz, 80, 80, true);
               MoveWindow(gamePiece[5], poseh, posez, 80, 80, true);
               MoveWindow(gamePiece[6], posfh, posfz, 80, 80, true);
               MoveWindow(gamePiece[7], posgh, posgz, 80, 80, true);
               MoveWindow(gamePiece[8], poshh, poshz, 80, 80, true);
               MoveWindow(gamePiece[9], posih, posiz, 80, 80, true);
               MoveWindow(gamePiece[10], posjh, posjz, 80, 80, true);
               MoveWindow(gamePiece[11], poskh, poskz, 80, 80, true);
               MoveWindow(gamePiece[12], poslh, poslz, 80, 80, true);
               MoveWindow(gamePiece[13], posmh, posmz, 80, 80, true);
               MoveWindow(gamePiece[14], posnh, posnz, 80, 80, true);
               MoveWindow(gamePiece[15], posoh, posoz, 80, 80, true);
               InvalidateRect((HWND)hwnd,NULL,false);
               UpdateWindow(hwnd);
               } 
                else{
                 MessageBeep(0);
                  }            
             }//Game Close 
                                         
             }//close switch
            } //close cmd      
                                          
        default:
            return DefWindowProc (hwnd, message, wParam, lParam);
    } //close callback

    return 0;
}
