#include <olectl.h>
#include <ole2.h>
#include <string>
#include <sstream>
#include "Row1.cpp"
#include "lodepng.h"
#include "lodepng.cpp"


std::string getDrivePath;
std::string RestoreBmp;
std::string myimage;
std::string vertimage;
std::string HelpFiler;
std::string clowntime;
std::string finalpath;
std::string blah;
std::string ifpng;
char* pngs;

//int is_magic=1;
 
int mutecntl=0;

void encodeBMP(std::vector<unsigned char>& bmp, const unsigned char* image, int w, int h)
{
  //3 bytes per pixel used for both input and output.
  int inputChannels = 3;
  int outputChannels = 3;
  
  //bytes 0-13
  bmp.push_back('B'); bmp.push_back('M'); //0: bfType
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); //2: bfSize; size not yet known for now, filled in later.
  bmp.push_back(0); bmp.push_back(0); //6: bfReserved1
  bmp.push_back(0); bmp.push_back(0); //8: bfReserved2
  bmp.push_back(54 % 256); bmp.push_back(54 / 256); bmp.push_back(0); bmp.push_back(0); //10: bfOffBits (54 header bytes)

  //bytes 14-53
  bmp.push_back(40); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //14: biSize
  bmp.push_back(w % 256); bmp.push_back(w / 256); bmp.push_back(0); bmp.push_back(0); //18: biWidth
  bmp.push_back(h % 256); bmp.push_back(h / 256); bmp.push_back(0); bmp.push_back(0); //22: biHeight
  bmp.push_back(1); bmp.push_back(0); //26: biPlanes
  bmp.push_back(outputChannels * 8); bmp.push_back(0); //28: biBitCount
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //30: biCompression
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //34: biSizeImage
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //38: biXPelsPerMeter
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //42: biYPelsPerMeter
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //46: biClrUsed
  bmp.push_back(0); bmp.push_back(0); bmp.push_back(0); bmp.push_back(0);  //50: biClrImportant
  
  /*
  Convert the input RGBRGBRGB pixel buffer to the BMP pixel buffer format. There are 3 differences with the input buffer:
  -BMP stores the rows inversed, from bottom to top
  -BMP stores the color channels in BGR instead of RGB order
  -BMP requires each row to have a multiple of 4 bytes, so sometimes padding bytes are added between rows
  */

  int imagerowbytes = outputChannels * w;
  imagerowbytes = imagerowbytes % 4 == 0 ? imagerowbytes : imagerowbytes + (4 - imagerowbytes % 4); //must be multiple of 4
  
  for(int y = h - 1; y >= 0; y--) //the rows are stored inversed in bmp
  {
    int c = 0;
    for(int x = 0; x < imagerowbytes; x++)
    {
      if(x < w * outputChannels)
      {
        int inc = c;
        //Convert RGB(A) into BGR(A)
        if(c == 0) inc = 2;
        else if(c == 2) inc = 0;
        bmp.push_back(image[inputChannels * (w * y + x / outputChannels) + inc]);
      }
      else bmp.push_back(0);
      c++;
      if(c >= outputChannels) c = 0;
    }
  }

  // Fill in the size
  bmp[2] = bmp.size() % 256;
  bmp[3] = (bmp.size() / 256) % 256;
  bmp[4] = (bmp.size() / 65536) % 256;
  bmp[5] = bmp.size() / 16777216;
} 
///////////////////////////////////////////////////////////////////////////////////////////////

        void LoadPic() 
         {
           is_magic=0;
           
           OPENFILENAME ofn;
           char szFileName[MAX_PATH] = "";
           ZeroMemory(&ofn, sizeof(ofn));
           ofn.lStructSize = sizeof(ofn); 
           ofn.lpstrInitialDir = RestoreBmp.c_str();
           ofn.hwndOwner = hwnd;
           //ofn.lpstrFilter = "Bmp File (*.bmp)\0*.bmp\0";
          // ofn.lpstrFilter = "Image Files (.GIF;*.JPG;*.BMP)\0*.GIF;*.JPG;*.BMP\0";
            ofn.lpstrFilter = "Image Files (*.GIF;*.JPG;*.BMP;*.PNG)\0*.GIF;*.JPG;*.BMP;*.PNG\0";
          // ofn.lpstrFilter = "Bmp File (*.bmp*)\0*.bmp\0JPEG File (*.jpg*)\0*.jpg\0GIF File (*.gif)\0*.gif\0";
           ofn.lpstrFile = szFileName;
           ofn.nMaxFile = MAX_PATH;
           ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST |OFN_HIDEREADONLY;
           ofn.lpstrDefExt = "";
           
          
         if (GetOpenFileName(&ofn)) 
         {
          myimage.erase();
          blah.erase();
          std::string blah=szFileName;
          ifpng=szFileName;

          std::string::size_type locad=ifpng.find_last_of(".");
          ifpng.erase(0,locad+1); //Retain only filetype
          
          if(ifpng=="png" || ifpng=="PNG"){

            std::vector<unsigned char> image; //the raw pixels
            unsigned width, height;

            unsigned error = lodepng::decode(image, width, height, szFileName, LCT_RGB, 8);

  if(error)
  {
    MessageBox(NULL,"Image failed to load. . . ","15 Puzzle Error",MB_OK);
    //return 0;
  }

  std::vector<unsigned char> bmp;
  encodeBMP(bmp, &image[0], width, height);
  
  lodepng::save_file(bmp, pngs);

FILE *pidFile2;
unsigned short bmpwidthb, bmpheightb, bmptossb;

pidFile2 = fopen(pngs, "rb");

fseek(pidFile2, 0x012, SEEK_SET);
fread(&bmpwidthb, sizeof(unsigned short), 1, pidFile2);
fread(&bmptossb, sizeof(unsigned short), 1, pidFile2);
fread(&bmpheightb,sizeof(unsigned short),1,pidFile2);

fclose(pidFile2);

   }      //ifpng.erase(); 
          clowntime=szFileName;
          std::string::size_type locab= clowntime.find_last_of("\\");
          clowntime.erase(0,locab+1);   /* Retain full pathway  */
          
          std::string::size_type locac= blah.find_last_of(".");
          blah.erase(0,locac+1);   /* Retain full pathway  */
          
          if(clowntime=="puznumbs.bmp")
           {
           is_magic=1;
           }
           
          std::stringstream ssa;
          ssa.unsetf(std::ios::skipws);
          ssa<<szFileName;
          myimage=ssa.str();
         // myimage=szFileName;
       
          
          NewBoard();
         
           MoveWindow(gamePiece[1], posah, posaz, 80, 80, true);
           MoveWindow(gamePiece[2], posbh, posbz, 80, 80, true);
           MoveWindow(gamePiece[3], posch, poscz, 80, 80, true);
           MoveWindow(gamePiece[4], posdh, posdz, 80, 80, true);
           MoveWindow(gamePiece[5], poseh, posez, 80, 80, true);
           MoveWindow(gamePiece[6], posfh, posfz, 80, 80, true);
           MoveWindow(gamePiece[7], posgh, posgz, 80, 80, true);
           MoveWindow(gamePiece[8], poshh, poshz, 80, 80, true);
           MoveWindow(gamePiece[9], posih, posiz, 80, 80, true);
           MoveWindow(gamePiece[10], posjh, posjz, 80, 80, true);
           MoveWindow(gamePiece[11], poskh, poskz, 80, 80, true);
           MoveWindow(gamePiece[12], poslh, poslz, 80, 80, true);
           MoveWindow(gamePiece[13], posmh, posmz, 80, 80, true);
           MoveWindow(gamePiece[14], posnh, posnz, 80, 80, true);                                                                                                                                    
           MoveWindow(gamePiece[15], posoh, posoz, 80, 80, true);
           setarray();
           
         //  InvalidateRect((HWND)hwnd,NULL,false);
         //  UpdateWindow(hwnd);           
          }
            }
////////////////////////////////////////////////////////////////            
void helpload()
 {
   HINSTANCE hRet = ShellExecute(
        HWND_DESKTOP,              //Parent window
        "open",             //Operation to perform
        HelpFiler.c_str(),       //Path to program
        NULL,                         //Parameters
        NULL,                  //Default directory
        SW_SHOW);                    //How to open
        
     if((LONG)hRet <= 32)
  {
    MessageBox(HWND_DESKTOP,"Help file could not be opened...",
    "Error - 15_ Sliders",MB_OK);
  }     
}
 ///////////////////////////////////////////////////////////////
 
HBITMAP hBB=NULL;

HBITMAP LoadAnImage(char* FileName)
 {
  IPicture* p;
  IStream* s;
  //IPersistStream* ps;
  HGLOBAL hG;
  void* pp;
  FILE* fp;
  //std::string stream myimage3;
  
  fp = fopen(FileName,"rb");
  if(!fp)
   return NULL;
  fseek(fp,0,SEEK_END);
  int fs = ftell(fp);
  fseek(fp,0,SEEK_SET);
  hG=GlobalAlloc(GPTR,fs);
 if(!hG)
  {
  fclose(fp);
  return NULL;
  }
    
   pp = (void*)hG;
   fread(pp,1,fs,fp);
   fclose(fp);
   
   CreateStreamOnHGlobal(hG,false,&s);
   if(!s)
     {
    GlobalFree(hG);
    return NULL;
    }
     
    OleLoadPicture(s,0,false,IID_IPicture,(void**)&p);
    if(!p)
     {
     s->Release();
     GlobalFree(hG);
     return NULL;
     }
      
     s->Release();
     GlobalFree(hG);
     
     HBITMAP hB = 0;
     p->get_Handle((unsigned int*)&hB);
     
     hBB= (HBITMAP)CopyImage(hB,IMAGE_BITMAP,192,192,
     LR_COPYRETURNORG);
     
     p->Release();
    // GlobalFree(hB);
     return hBB;
 
     }  
 
 /////////////////////////////////////////////////////////////////////////
 
 void CaptureWindow (HWND hwnd)
{
    RECT            rect;
	HDC				src_hdc=NULL;
	HDC				dst_hdc=NULL;
	HBITMAP			hbitmap;
	BITMAPINFO		bi;
	LPBYTE			pBits;
	int				w;
	int				h;
	HANDLE			file_handle;

	GetClientRect ( hwnd, &rect );

	w = rect.right - rect.left;
	h = rect.bottom - rect.top;

	src_hdc = GetDC ( hwnd );

	dst_hdc = CreateCompatibleDC ( src_hdc );

	ZeroMemory ( &bi, sizeof ( bi ) );
	bi.bmiHeader.biSize = sizeof ( bi.bmiHeader );
	bi.bmiHeader.biHeight = h;
	bi.bmiHeader.biWidth = w;
	bi.bmiHeader.biPlanes = 1;
	bi.bmiHeader.biBitCount = 24;
	bi.bmiHeader.biCompression = BI_RGB;
	bi.bmiHeader.biSizeImage = ((w * bi.bmiHeader.biBitCount +31)& ~31) / 8 * h; 

	hbitmap = CreateDIBSection ( src_hdc, &bi, DIB_RGB_COLORS, (LPVOID *) &pBits, NULL, 0 );

	SelectObject ( dst_hdc, hbitmap );		

	if ( BitBlt ( dst_hdc, 0, 0, w, h, src_hdc, rect.left, rect.top, SRCCOPY ) ) {

	  	file_handle = CreateFile ( finalpath.c_str(), GENERIC_WRITE, FILE_SHARE_WRITE, NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );	

		if ( file_handle != INVALID_HANDLE_VALUE ) {
			DWORD				dwRet = 0;
			BITMAPFILEHEADER	bfh;

			ZeroMemory ( &bfh, sizeof ( bfh ) );
			bfh.bfType = 0x4D42;
			bfh.bfOffBits = sizeof ( BITMAPFILEHEADER ) + sizeof ( BITMAPINFOHEADER );
			bfh.bfSize = bi.bmiHeader.biSizeImage + bfh.bfOffBits;

	 		WriteFile ( file_handle, &bfh, sizeof ( bfh ), &dwRet, NULL);
			WriteFile ( file_handle, &bi.bmiHeader, sizeof ( bi.bmiHeader ), &dwRet, NULL );
			WriteFile ( file_handle, pBits, bi.bmiHeader.biSizeImage, &dwRet, NULL );
		}

		CloseHandle ( file_handle );
		DeleteDC ( dst_hdc );
		DeleteObject ( hbitmap );
   		ReleaseDC ( hwnd, src_hdc );
	}
}
           
